import{s as je,f as Ie,n as Be,o as We}from"../chunks/scheduler.37c15a92.js";import{S as Ze,i as De,g as a,s as r,r as Gt,m as p,H as nt,A as Je,h as l,f as e,c as o,j as c,u as Ot,x as m,n as h,B as at,k as T,y as i,a as n,v as Nt,d as qt,t as Ft,w as jt}from"../chunks/index.7cb9c9b8.js";import{H as Bt}from"../chunks/Heading.d3928e2a.js";function Ke(fe){let u,lt,et,it,L,rt,M,ve="Before training our agent, we need to understand <strong>what ML-Agents is and how it works</strong>.",ot,C,mt,k,de='<a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents</a> is a toolkit for the game engine Unity that <strong>allows us to create environments using Unity or use pre-made environments to train our agents</strong>.',pt,A,we='It’s developed by <a href="https://unity.com/" rel="nofollow">Unity Technologies</a>, the developers of Unity, one of the most famous Game Engines used by the creators of Firewatch, Cuphead, and Cities: Skylines.',ht,b,ye='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/firewatch.jpeg" alt="Firewatch"/> <figcaption>Firewatch was made with Unity</figcaption>',gt,$,ct,H,xe="With Unity ML-Agents, you have six essential components:",ut,P,_e='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/mlagents-1.png" alt="MLAgents"/> <figcaption>Source: <a href="https://unity-technologies.github.io/ml-agents/">Unity ML-Agents Documentation</a></figcaption>',ft,R,Te="<li>The first is the <em>Learning Environment</em>, which contains <strong>the Unity scene (the environment) and the environment elements</strong> (game characters).</li> <li>The second is the <em>Python Low-level API</em>, which contains <strong>the low-level Python interface for interacting and manipulating the environment</strong>. It’s the API we use to launch the training.</li> <li>Then, we have the <em>External Communicator</em> that <strong>connects the Learning Environment (made with C#) with the low level Python API (Python)</strong>.</li> <li>The <em>Python trainers</em>: the <strong>Reinforcement algorithms made with PyTorch (PPO, SAC…)</strong>.</li> <li>The <em>Gym wrapper</em>: to encapsulate the RL environment in a gym wrapper.</li> <li>The <em>PettingZoo wrapper</em>: PettingZoo is the multi-agents version of the gym wrapper.</li>",vt,E,dt,S,Le="Inside the Learning Component, we have <strong>two important elements</strong>:",wt,U,Me="<li>The first is the <em>agent component</em>, the actor of the scene. We’ll <strong>train the agent by optimizing its policy</strong> (which will tell us what action to take in each state). The policy is called the <em>Brain</em>.</li> <li>Finally, there is the <em>Academy</em>. This component <strong>orchestrates agents and their decision-making processes</strong>. Think of this Academy as a teacher who handles Python API requests.</li>",yt,z,Ce="To better understand its role, let’s remember the RL process. This can be modeled as a loop that works like this:",xt,I,ke='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process.jpg" alt="The RL process" width="100%"/> <figcaption>The RL Process: a loop of state, action, reward and next state</figcaption> <figcaption>Source: <a href="http://incompleteideas.net/book/RLbook2020.pdf">Reinforcement Learning: An Introduction, Richard Sutton and Andrew G. Barto</a></figcaption>',_t,G,Ae="Now, let’s imagine an agent learning to play a platform game. The RL process looks like this:",Tt,y,be,Lt,g,f,Wt,B,Zt,Mt,Ge='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Dt,W,$e="Environment",Jt,Kt,v,Qt,O,Vt,Ct,Oe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',kt,Xt,Z,Yt,At,Ne='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">A_0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',te,ee,d,se,D,He="new",ne,J,ae,bt,qe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">S_1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',le,ie,w,re,K,oe,$t,Fe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">R_1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',me,Q,Pe="(Positive Reward +1)",pe,Ht,N,Re="This RL loop outputs a sequence of <strong>state, action, reward and next state.</strong> The goal of the agent is to <strong>maximize the expected cumulative reward</strong>.",Pt,q,Ee="The Academy will be the one that will <strong>send the order to our Agents and ensure that agents are in sync</strong>:",Rt,F,Se="<li>Collect Observations</li> <li>Select your action using your policy</li> <li>Take the Action</li> <li>Reset if you reached the max step or if you’re done.</li>",Et,x,Ue,St,j,ze="Now that we understand how ML-Agents works, <strong>we’re ready to train our agents.</strong>",Ut,st,zt;return L=new Bt({props:{title:"How do Unity ML-Agents work?",local:"how-mlagents-works",headingTag:"h1"}}),C=new Bt({props:{title:"What is Unity ML-Agents?",local:"what-is-mlagents",headingTag:"h2"}}),$=new Bt({props:{title:"The six components",local:"six-components",headingTag:"h2"}}),E=new Bt({props:{title:"Inside the Learning Component",local:"inside-learning-component",headingTag:"h2"}}),{c(){u=a("meta"),lt=r(),et=a("p"),it=r(),Gt(L.$$.fragment),rt=r(),M=a("p"),M.innerHTML=ve,ot=r(),Gt(C.$$.fragment),mt=r(),k=a("p"),k.innerHTML=de,pt=r(),A=a("p"),A.innerHTML=we,ht=r(),b=a("figure"),b.innerHTML=ye,gt=r(),Gt($.$$.fragment),ct=r(),H=a("p"),H.textContent=xe,ut=r(),P=a("figure"),P.innerHTML=_e,ft=r(),R=a("ul"),R.innerHTML=Te,vt=r(),Gt(E.$$.fragment),dt=r(),S=a("p"),S.innerHTML=Le,wt=r(),U=a("ul"),U.innerHTML=Me,yt=r(),z=a("p"),z.textContent=Ce,xt=r(),I=a("figure"),I.innerHTML=ke,_t=r(),G=a("p"),G.textContent=Ae,Tt=r(),y=a("img"),Lt=r(),g=a("ul"),f=a("li"),Wt=p("Our Agent receives "),B=a("strong"),Zt=p("state "),Mt=new nt(!1),Dt=p(" from the "),W=a("strong"),W.textContent=$e,Jt=p(" — we receive the first frame of our game (Environment)."),Kt=r(),v=a("li"),Qt=p("Based on that "),O=a("strong"),Vt=p("state"),Ct=new nt(!1),kt=p(","),Xt=p(" the Agent takes "),Z=a("strong"),Yt=p("action"),At=new nt(!1),te=p(" — our Agent will move to the right."),ee=r(),d=a("li"),se=p("The environment goes to a "),D=a("strong"),D.textContent=He,ne=p(" "),J=a("strong"),ae=p("state"),bt=new nt(!1),le=p(" — new frame."),ie=r(),w=a("li"),re=p("The environment gives some "),K=a("strong"),oe=p("reward"),$t=new nt(!1),me=p(" to the Agent — we’re not dead "),Q=a("em"),Q.textContent=Pe,pe=p("."),Ht=r(),N=a("p"),N.innerHTML=Re,Pt=r(),q=a("p"),q.innerHTML=Ee,Rt=r(),F=a("ul"),F.innerHTML=Se,Et=r(),x=a("img"),St=r(),j=a("p"),j.innerHTML=ze,Ut=r(),st=a("p"),this.h()},l(t){const s=Je("svelte-u9bgzb",document.head);u=l(s,"META",{name:!0,content:!0}),s.forEach(e),lt=o(t),et=l(t,"P",{}),c(et).forEach(e),it=o(t),Ot(L.$$.fragment,t),rt=o(t),M=l(t,"P",{"data-svelte-h":!0}),m(M)!=="svelte-15uedik"&&(M.innerHTML=ve),ot=o(t),Ot(C.$$.fragment,t),mt=o(t),k=l(t,"P",{"data-svelte-h":!0}),m(k)!=="svelte-av0s9x"&&(k.innerHTML=de),pt=o(t),A=l(t,"P",{"data-svelte-h":!0}),m(A)!=="svelte-fzslkd"&&(A.innerHTML=we),ht=o(t),b=l(t,"FIGURE",{"data-svelte-h":!0}),m(b)!=="svelte-ymq6bm"&&(b.innerHTML=ye),gt=o(t),Ot($.$$.fragment,t),ct=o(t),H=l(t,"P",{"data-svelte-h":!0}),m(H)!=="svelte-dq339q"&&(H.textContent=xe),ut=o(t),P=l(t,"FIGURE",{"data-svelte-h":!0}),m(P)!=="svelte-10um3w0"&&(P.innerHTML=_e),ft=o(t),R=l(t,"UL",{"data-svelte-h":!0}),m(R)!=="svelte-2em1lc"&&(R.innerHTML=Te),vt=o(t),Ot(E.$$.fragment,t),dt=o(t),S=l(t,"P",{"data-svelte-h":!0}),m(S)!=="svelte-7x17zy"&&(S.innerHTML=Le),wt=o(t),U=l(t,"UL",{"data-svelte-h":!0}),m(U)!=="svelte-6e1ah7"&&(U.innerHTML=Me),yt=o(t),z=l(t,"P",{"data-svelte-h":!0}),m(z)!=="svelte-1nodyfp"&&(z.textContent=Ce),xt=o(t),I=l(t,"FIGURE",{"data-svelte-h":!0}),m(I)!=="svelte-ddctb4"&&(I.innerHTML=ke),_t=o(t),G=l(t,"P",{"data-svelte-h":!0}),m(G)!=="svelte-l0svdt"&&(G.textContent=Ae),Tt=o(t),y=l(t,"IMG",{src:!0,alt:!0,width:!0}),Lt=o(t),g=l(t,"UL",{});var _=c(g);f=l(_,"LI",{});var V=c(f);Wt=h(V,"Our Agent receives "),B=l(V,"STRONG",{});var he=c(B);Zt=h(he,"state "),Mt=at(he,!1),he.forEach(e),Dt=h(V," from the "),W=l(V,"STRONG",{"data-svelte-h":!0}),m(W)!=="svelte-17f3im9"&&(W.textContent=$e),Jt=h(V," — we receive the first frame of our game (Environment)."),V.forEach(e),Kt=o(_),v=l(_,"LI",{});var X=c(v);Qt=h(X,"Based on that "),O=l(X,"STRONG",{});var It=c(O);Vt=h(It,"state"),Ct=at(It,!1),kt=h(It,","),It.forEach(e),Xt=h(X," the Agent takes "),Z=l(X,"STRONG",{});var ge=c(Z);Yt=h(ge,"action"),At=at(ge,!1),ge.forEach(e),te=h(X," — our Agent will move to the right."),X.forEach(e),ee=o(_),d=l(_,"LI",{});var Y=c(d);se=h(Y,"The environment goes to a "),D=l(Y,"STRONG",{"data-svelte-h":!0}),m(D)!=="svelte-xvdw54"&&(D.textContent=He),ne=h(Y," "),J=l(Y,"STRONG",{});var ce=c(J);ae=h(ce,"state"),bt=at(ce,!1),ce.forEach(e),le=h(Y," — new frame."),Y.forEach(e),ie=o(_),w=l(_,"LI",{});var tt=c(w);re=h(tt,"The environment gives some "),K=l(tt,"STRONG",{});var ue=c(K);oe=h(ue,"reward"),$t=at(ue,!1),ue.forEach(e),me=h(tt," to the Agent — we’re not dead "),Q=l(tt,"EM",{"data-svelte-h":!0}),m(Q)!=="svelte-wepaxr"&&(Q.textContent=Pe),pe=h(tt,"."),tt.forEach(e),_.forEach(e),Ht=o(t),N=l(t,"P",{"data-svelte-h":!0}),m(N)!=="svelte-3iun6t"&&(N.innerHTML=Re),Pt=o(t),q=l(t,"P",{"data-svelte-h":!0}),m(q)!=="svelte-1q61jnh"&&(q.innerHTML=Ee),Rt=o(t),F=l(t,"UL",{"data-svelte-h":!0}),m(F)!=="svelte-w2l7uo"&&(F.innerHTML=Se),Et=o(t),x=l(t,"IMG",{src:!0,alt:!0,width:!0}),St=o(t),j=l(t,"P",{"data-svelte-h":!0}),m(j)!=="svelte-1j4rf70"&&(j.innerHTML=ze),Ut=o(t),st=l(t,"P",{}),c(st).forEach(e),this.h()},h(){T(u,"name","hf:doc:metadata"),T(u,"content",Qe),Ie(y.src,be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process_game.jpg")||T(y,"src",be),T(y,"alt","The RL process"),T(y,"width","100%"),Mt.a=null,Ct.a=kt,At.a=null,bt.a=null,$t.a=null,Ie(x.src,Ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/academy.png")||T(x,"src",Ue),T(x,"alt","The MLAgents Academy"),T(x,"width","100%")},m(t,s){i(document.head,u),n(t,lt,s),n(t,et,s),n(t,it,s),Nt(L,t,s),n(t,rt,s),n(t,M,s),n(t,ot,s),Nt(C,t,s),n(t,mt,s),n(t,k,s),n(t,pt,s),n(t,A,s),n(t,ht,s),n(t,b,s),n(t,gt,s),Nt($,t,s),n(t,ct,s),n(t,H,s),n(t,ut,s),n(t,P,s),n(t,ft,s),n(t,R,s),n(t,vt,s),Nt(E,t,s),n(t,dt,s),n(t,S,s),n(t,wt,s),n(t,U,s),n(t,yt,s),n(t,z,s),n(t,xt,s),n(t,I,s),n(t,_t,s),n(t,G,s),n(t,Tt,s),n(t,y,s),n(t,Lt,s),n(t,g,s),i(g,f),i(f,Wt),i(f,B),i(B,Zt),Mt.m(Ge,B),i(f,Dt),i(f,W),i(f,Jt),i(g,Kt),i(g,v),i(v,Qt),i(v,O),i(O,Vt),Ct.m(Oe,O),i(O,kt),i(v,Xt),i(v,Z),i(Z,Yt),At.m(Ne,Z),i(v,te),i(g,ee),i(g,d),i(d,se),i(d,D),i(d,ne),i(d,J),i(J,ae),bt.m(qe,J),i(d,le),i(g,ie),i(g,w),i(w,re),i(w,K),i(K,oe),$t.m(Fe,K),i(w,me),i(w,Q),i(w,pe),n(t,Ht,s),n(t,N,s),n(t,Pt,s),n(t,q,s),n(t,Rt,s),n(t,F,s),n(t,Et,s),n(t,x,s),n(t,St,s),n(t,j,s),n(t,Ut,s),n(t,st,s),zt=!0},p:Be,i(t){zt||(qt(L.$$.fragment,t),qt(C.$$.fragment,t),qt($.$$.fragment,t),qt(E.$$.fragment,t),zt=!0)},o(t){Ft(L.$$.fragment,t),Ft(C.$$.fragment,t),Ft($.$$.fragment,t),Ft(E.$$.fragment,t),zt=!1},d(t){t&&(e(lt),e(et),e(it),e(rt),e(M),e(ot),e(mt),e(k),e(pt),e(A),e(ht),e(b),e(gt),e(ct),e(H),e(ut),e(P),e(ft),e(R),e(vt),e(dt),e(S),e(wt),e(U),e(yt),e(z),e(xt),e(I),e(_t),e(G),e(Tt),e(y),e(Lt),e(g),e(Ht),e(N),e(Pt),e(q),e(Rt),e(F),e(Et),e(x),e(St),e(j),e(Ut),e(st)),e(u),jt(L,t),jt(C,t),jt($,t),jt(E,t)}}}const Qe='{"title":"How do Unity ML-Agents work?","local":"how-mlagents-works","sections":[{"title":"What is Unity ML-Agents?","local":"what-is-mlagents","sections":[],"depth":2},{"title":"The six components","local":"six-components","sections":[],"depth":2},{"title":"Inside the Learning Component","local":"inside-learning-component","sections":[],"depth":2}],"depth":1}';function Ve(fe){return We(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class es extends Ze{constructor(u){super(),De(this,u,Ve,Ke,je,{})}}export{es as component};
